searchData={"items":[{"type":"module","title":"Sanity.Components.Image","doc":"For rendering a [Sanity image asset](https://www.sanity.io/docs/assets).","ref":"Sanity.Components.Image.html"},{"type":"module","title":"Examples - Sanity.Components.Image","doc":"use Phoenix.Component\n\n    # ...\n\n    # Example of image asset returned by Sanity CMS API\n    assigns = %{\n      image: %{\n        _id: \"image-da994d9e87efb226111cb83dbbab832d45b1365e-1500x750-jpg\",\n        _type: \"sanity.imageAsset\",\n        metadata: %{\n          dimensions: %{height: 750, width: 1500},\n          palette: %{dominant: %{background: \"#0844c5\"}}\n        },\n        mime_type: \"image/jpeg\",\n        url:\n          \"https://cdn.sanity.io/images/csbsxnjq/production/da994d9e87efb226111cb83dbbab832d45b1365e-1500x750.jpg\"\n      }\n    }\n\n    ~H\" \"","ref":"Sanity.Components.Image.html#module-examples"},{"type":"function","title":"Sanity.Components.Image.projection/0","doc":"Returns a GROQ projection for a Sanity image.","ref":"Sanity.Components.Image.html#projection/0"},{"type":"function","title":"Sanity.Components.Image.sanity_image/1","doc":"Renders a responsive sanity image.\n\nThe `src` and `srcset` attributes will be automatically set. Sanity CMS will [take care of\nresizing the images and serving WebP images to supported\nbrowsers](https://www.sanity.io/docs/image-urls).\n\nThe `width` and `height` attributes will be automatically set to the dimensions of the image.\nThis ensures that on [modern\nbrowsers](https://caniuse.com/mdn-html_elements_img_aspect_ratio_computed_from_attributes) the\nimage will have the correct aspect ratio before the image loads. This avoids [layout\nshift](https://web.dev/cls/).\n\nThe following CSS custom properties will be set if present in the Sanity image metadata:\n\n  - `--sanity-image-bg` - Dominant background color of image. Useful for rendering placeholders.\n  - `--sanity-image-height` and `--sanity-image-width` - Height/width of image.\n\nSee module doc for example.","ref":"Sanity.Components.Image.html#sanity_image/1"},{"type":"function","title":"Attributes - Sanity.Components.Image.sanity_image/1","doc":"* `image` (`:any`) (required)\n* `height` (`:integer`) - Defaults to `nil`.\n* `width` (`:integer`) - Defaults to `nil`.\n* `style` (`:string`) - Defaults to `nil`.\n* `sizes` (`:string`) - Defaults to `\"100vw\"`.\n* Global attributes are accepted.","ref":"Sanity.Components.Image.html#sanity_image/1-attributes"},{"type":"module","title":"Sanity.Components.PortableText","doc":"For rending [Sanity CMS portable text](https://www.sanity.io/docs/presenting-block-text).","ref":"Sanity.Components.PortableText.html"},{"type":"module","title":"Examples - Sanity.Components.PortableText","doc":"","ref":"Sanity.Components.PortableText.html#module-examples"},{"type":"module","title":"Basic example - Sanity.Components.PortableText","doc":"use Phoenix.Component\n\n    # ...\n\n    assigns = %{\n      portable_text: [\n        %{\n          _key: \"f71173c80e3a\",\n          _type: \"block\",\n          children: [%{_key: \"d6c419dcf485\", _type: \"span\", marks: [], text: \"Test paragraph.\"}],\n          mark_defs: [],\n          style: \"normal\"\n        }\n      ]\n    }\n\n    ~H\" \"","ref":"Sanity.Components.PortableText.html#module-basic-example"},{"type":"module","title":"Custom rendering - Sanity.Components.PortableText","doc":"defmodule CustomBlock do\n      use Phoenix.Component\n      use Sanity.Components.PortableText\n\n      @impl true\n      def block(%{value: %{style: \"normal\"}} = assigns) do\n        ~H\"\"\"\n         <%= render_slot(@inner_block) %> \n        \"\"\"\n      end\n\n      def block(assigns), do: super(assigns)\n    end\n\nThen render the component like:\n\n    ~H\" \"\n\nSimilarly, marks and types can be customized by defining `mark/1` and `type/1` functions in the module.","ref":"Sanity.Components.PortableText.html#module-custom-rendering"},{"type":"function","title":"Sanity.Components.PortableText.portable_text/1","doc":"Renders Sanity CMS portable text. See module doc for examples.","ref":"Sanity.Components.PortableText.html#portable_text/1"},{"type":"function","title":"Attributes - Sanity.Components.PortableText.portable_text/1","doc":"* `value` (`:any`) (required)\n* `mod` (`:atom`) - Defaults to `Sanity.Components.PortableText`.","ref":"Sanity.Components.PortableText.html#portable_text/1-attributes"},{"type":"function","title":"Sanity.Components.PortableText.to_plain_text/1","doc":"Converts list of blocks to plain text.","ref":"Sanity.Components.PortableText.html#to_plain_text/1"},{"type":"extras","title":"Sanity.Components","doc":"# `Sanity.Components`\n\n[![Package](https://img.shields.io/hexpm/v/sanity_components.svg)](https://hex.pm/packages/sanity_components) [![Documentation](http://img.shields.io/badge/hex.pm-docs-green.svg?style=flat)](https://hexdocs.pm/sanity_components) ![CI](https://github.com/balexand/sanity_components/actions/workflows/elixir.yml/badge.svg)\n\nPhoenix components for rendering Sanity CMS data, including portable text and images.","ref":"readme.html"},{"type":"extras","title":"Installation - Sanity.Components","doc":"The package can be installed by adding `sanity_components` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:sanity_components, \"~> 0.13\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Sanity.Components","doc":"Start by fetching data from Sanity CMS using the [`sanity` client library](https://github.com/balexand/sanity). Components in this package expect map keys to be atoms in `underscore_case`.\n\nSee docs for:\n\n* [Rendering portable text](https://hexdocs.pm/sanity_components/Sanity.Components.PortableText.html)\n* [Rendering sanity images](https://hexdocs.pm/sanity_components/Sanity.Components.Image.html)","ref":"readme.html#usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}